// Boot.cpp: implementation of the CBoot class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Boot.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CBoot::CBoot()
{
}

CBoot::~CBoot()
{
}

BOOL CBoot::Logoff(BOOL bEmergency,BOOL bShowWarning)
{
	return Boot(EWX_LOGOFF,bEmergency);
}
BOOL CBoot::Poweroff(BOOL bEmergency,BOOL bShowWarning)
{
	return Boot(EWX_POWEROFF,bEmergency,bShowWarning);
}
BOOL CBoot::Reboot(BOOL bEmergency,BOOL bShowWarning)
{
	return Boot(EWX_REBOOT,bEmergency,bShowWarning);
}
BOOL CBoot::Shutdown(BOOL bEmergency,BOOL bShowWarning)
{
	return Boot(EWX_SHUTDOWN,bEmergency,bShowWarning);
}

//NOTE : that installed app should have SE_SHUTDOWN_NAME privilege. For more information,
//see the following Remarks section of ExitWindowsEx in MSDN ...
BOOL CBoot::Boot(UINT uFlags,BOOL bEmergency,BOOL bShowWarning)
{
	if (!uFlags)
		return FALSE;

	if (bShowWarning) {
		int nResult = Warning();
		if (nResult==0 || nResult==IDNO)
			return FALSE;
	}

	if (bEmergency) 
		uFlags |= EWX_FORCE;
	//force boot (NOTICE !!! : apps may loose information)
	
	return ::ExitWindowsEx(uFlags,0);
}
